SystemOrganization addCategory: #'SmaCC-Tutorial'!

SmaCCScanner subclass: #CalculatorScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
emptySymbolTokenId
	^ 19! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
errorTokenId
	^ 20! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
scanForToken
	self step.
	currentCharacter == $(
		ifTrue: [ ^ self recordAndReportMatch: #(8) ].
	currentCharacter == $)
		ifTrue: [ ^ self recordAndReportMatch: #(7) ].
	currentCharacter == $*
		ifTrue: [ ^ self recordAndReportMatch: #(3) ].
	currentCharacter == $+
		ifTrue: [ ^ self recordAndReportMatch: #(2) ].
	currentCharacter == $,
		ifTrue: [ ^ self recordAndReportMatch: #(4) ].
	^ self scanForTokenX4! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
scanForTokenX1
	[ self recordMatch: #(10).
	self step.
	(currentCharacter between: $0 and: $9)
		or: [ (currentCharacter between: $A and: $Z)
				or: [ currentCharacter == $_ or: [ currentCharacter between: $a and: $z ] ] ] ]
		whileTrue! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
scanForTokenX2
	[ self recordMatch: #(9).
	self step.
	currentCharacter == $.
		ifTrue: [ [ self recordMatch: #(9).
			self step.
			currentCharacter between: $0 and: $9 ] whileTrue.
			^ self reportLastMatch ].
	currentCharacter between: $0 and: $9 ] whileTrue.
	^ self reportLastMatch! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
scanForTokenX3
	[ self recordMatch: #(11).
	self step.
	currentCharacter isSeparator
		or: [ currentCharacter == Character pageUp ] ] whileTrue.
	^ self reportLastMatch! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
scanForTokenX4
	currentCharacter == $-
		ifTrue: [ ^ self recordAndReportMatch: #(1) ].
	currentCharacter == $/
		ifTrue: [ ^ self recordAndReportMatch: #(5) ].
	currentCharacter == $^
		ifTrue: [ ^ self recordAndReportMatch: #(6) ].
	currentCharacter == $`
		ifTrue: [ [ self step.
			currentCharacter == $`
				ifTrue: [ ^ self recordAndReportMatch: #(12) ].
			true ] whileTrue ].
	(currentCharacter between: $0 and: $9)
		ifTrue:
			[ ^ self scanForTokenX2 ].
	(currentCharacter isSeparator
		or: [ currentCharacter == Character pageUp ])
		ifTrue:
			[ ^ self scanForTokenX3 ].
	((currentCharacter between: $A and: $Z)
		or: [ currentCharacter between: $a and: $z ])
		ifTrue:
			[ self scanForTokenX1 ].
	^ self reportLastMatch! !

!CalculatorScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
tokenActions
	^ #(nil nil nil nil nil nil nil nil nil nil #whitespace #patternToken)! !

SmaCCScanner subclass: #ListNameScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ListNameScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
emptySymbolTokenId
	^ 10! !

!ListNameScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
errorTokenId
	^ 11! !

!ListNameScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
scanForToken
	self recordMatch: #(3).
	self step.
	currentCharacter == $,
		ifTrue: [ ^ self recordAndReportMatch: #(1) ].
	((currentCharacter between: $A and: $Z)
		or: [ currentCharacter between: $a and: $z ])
		ifTrue: [ [ self recordMatch: #(2).
			self step.
			currentCharacter == $'
				or: [ (currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z)
								or: [ currentCharacter == $_ or: [ currentCharacter between: $a and: $z ] ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter == Character cr
		or: [ currentCharacter == Character space
				or: [ currentCharacter = (Character value: 160) ] ])
		ifTrue: [ [ self recordMatch: #(3).
			self step.
			currentCharacter == Character cr
				or: [ currentCharacter == Character space
						or: [ currentCharacter = (Character value: 160) ] ] ] whileTrue ].
	^ self reportLastMatch! !

!ListNameScanner methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
tokenActions
	^ #(nil nil #whitespace)! !

SmaCCGLRParser subclass: #CalculatorParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!CalculatorParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/4/2018 19:50'!
cacheId
	^'2018-12-04T19:50:42.551207+01:00'! !

!CalculatorParser class methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
definitionComment
"<number> : [0-9]+ (\. [0-9]*) ? ;
	<name> : [a-zA-Z]\w*;
	<whitespace> : \s+;

	<patternToken> : \` [^\`]* \` ;
		%glr;

	%left ""+"" ""-"";
	%left ""*"" ""/"";
	%right ""^"";

	%annotate_tokens;
	%root Expression;
	%prefix AST;
	%suffix Node;
	%ignore_variables leftParenToken rightParenToken;

	Expression 
		: Expression 'left' ""+"" 'operator' Expression 'right' {{Binary}}
		| Expression 'left' ""-"" 'operator' Expression 'right' {{Binary}}
		| Expression 'left' ""*"" 'operator' Expression 'right' {{Binary}}
		| Expression 'left' ""/"" 'operator' Expression 'right' {{Binary}}
		| Expression 'left' ""^"" 'operator' Expression 'right' {{Binary}}
		| ""("" Expression "")"" {{}}
		| Number
		| Function
        ;

	Number
        : <number> {{Number}}
        ;

	Function
		: <name> ""("" 'leftParen' (Expression 'argument' ("","" Expression 'argument')* )? "")"" 'rightParen' {{}}
        ;"! !

!CalculatorParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/4/2018 01:55'!
scannerClass
	^CalculatorScanner! !

!CalculatorParser class methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 01:55'!
startingStateForExpression
	^ 1! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:10'!
reduceActionForExpression2: nodes
	| result |
	result := ASTBinaryNode new.
	result left: (nodes at: 1).
	result operator: (nodes at: 2).
	result right: (nodes at: 3).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:10'!
reduceActionForExpression6: nodes
	| result |
	result := nodes at: 2.
	result addFirstToken: (nodes at: 1) to: result leftParenTokens.
	result addToken: (nodes at: 3) to: result rightParenTokens.
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:10'!
reduceActionForExpression7: nodes
	^ nodes at: 1! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionForFunction1: nodes
	| result |
	result := ASTFunctionNode new.
	result nameToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result arguments.
	result addTokens: ((nodes at: 3) at: 2) to: result commaTokens.
	result rightParen: (nodes at: 4).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:10'!
reduceActionForNumber1: nodes
	| result |
	result := ASTNumberNode new.
	result numberToken: (nodes at: 1).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionFor__Expression__argument________Expression__argument____1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 1).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionFor__Expression__argument________Expression__argument_____1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionFor__Expression__argument________Expression__argument_____2: nodes
	| result |
	result := nodes at: 1.
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionFor______Expression__argument__1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^ result! !

!CalculatorParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 02:41'!
reduceActionFor______Expression__argument___2: nodes
	| result |
	result := nodes at: 1.
	self add: ((nodes at: 2) at: 1) to: (result at: 1).
	self add: ((nodes at: 2) at: 2) to: (result at: 2).
	^ result! !

!CalculatorParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
reduceTable
^#(
	#(14 1 #reduceActionForNumber1:) 
	#(21 1 #reduceActionForExpression7:) 
	#(18 0 #reduceActionFor__Expression__argument________Expression__argument_____1:) 
	#(21 3 #reduceActionForExpression6:) 
	#(18 1 #reduceActionFor__Expression__argument________Expression__argument_____2:) 
	#(16 0 #reduceActionFor__Expression__argument________Expression__argument_____1:) 
	#(21 3 #reduceActionForExpression2:) 
	#(22 4 #reduceActionForFunction1:) 
	#(17 2 #reduceActionFor__Expression__argument________Expression__argument____1:) 
	#(16 2 #reduceActionFor______Expression__argument___2:) 
	#(15 2 #reduceActionFor______Expression__argument__1:)
	).! !

!CalculatorParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
symbolNames
	^ #('"-"' '"+"' '"*"' '","' '"/"' '"^"' '")"' '"("' '<number>' '<name>' '<whitespace>' '<patternToken>' 'B e g i n' 'Number' '( "," Expression ''argument'')' '( "," Expression ''argument'')*' '( Expression ''argument'' ( "," Expression ''argument'')*)' '( Expression ''argument'' ( "," Expression ''argument'')*)?' 'E O F' 'error' 'Expression' 'Function')! !

!CalculatorParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
symbolTypes
	^ #(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #ASTExpressionNode #ASTNumberNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #SmaCCToken #ASTExpressionNode #ASTFunctionNode)! !

!CalculatorParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 19:50'!
transitionTable
^#(
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 25 0 21 0 29 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 49 0 21 0 53 0 22] 
#[0 0 6 0 1 0 2 0 3 0 5 0 6 0 19] 
#[0 0 57 0 8] 
#[0 0 10 0 1 0 2 0 3 0 5 0 6 0 19] 
#[1 0 61 0 1 0 65 0 2 0 69 0 3 0 73 0 5 0 77 0 6 0 0 0 19] 
#[0 0 10 0 1 0 2 0 3 0 5 0 6 0 19] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 81 0 21 0 53 0 22] 
#[0 0 6 0 1 0 2 0 3 0 5 0 6 0 7] 
#[0 0 85 0 8] 
#[0 0 10 0 1 0 2 0 3 0 5 0 6 0 7] 
#[1 0 89 0 1 0 93 0 2 0 97 0 3 0 101 0 5 0 105 0 6 0 109 0 7] 
#[0 0 10 0 1 0 2 0 3 0 5 0 6 0 7] 
#[1 0 14 0 7 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 129 0 17 0 133 0 18 0 137 0 21 0 141 0 22] 
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 145 0 21 0 29 0 22] 
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 149 0 21 0 29 0 22] 
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 153 0 21 0 29 0 22] 
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 157 0 21 0 29 0 22] 
#[1 0 9 0 8 0 13 0 9 0 17 0 10 0 21 0 14 0 161 0 21 0 29 0 22] 
#[1 0 89 0 1 0 93 0 2 0 97 0 3 0 101 0 5 0 105 0 6 0 165 0 7] 
#[1 0 14 0 7 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 129 0 17 0 169 0 18 0 137 0 21 0 141 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 173 0 21 0 53 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 177 0 21 0 53 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 181 0 21 0 53 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 185 0 21 0 53 0 22] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 189 0 21 0 53 0 22] 
#[0 0 18 0 1 0 2 0 3 0 5 0 6 0 19] 
#[1 0 33 0 8 0 37 0 9 0 41 0 10 0 45 0 14 0 193 0 21 0 53 0 22] 
#[0 0 6 0 1 0 2 0 3 0 4 0 5 0 6 0 7] 
#[0 0 197 0 8] 
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7] 
#[0 0 22 0 7] 
#[0 0 201 0 7] 
#[1 0 205 0 1 0 209 0 2 0 213 0 3 0 26 0 4 0 217 0 5 0 221 0 6 0 26 0 7 0 225 0 16] 
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7] 
#[1 0 30 0 1 0 30 0 2 0 69 0 3 0 73 0 5 0 77 0 6 0 30 0 19] 
#[1 0 30 0 1 0 30 0 2 0 69 0 3 0 73 0 5 0 77 0 6 0 30 0 19] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 77 0 6 0 30 0 19] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 77 0 6 0 30 0 19] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 77 0 6 0 30 0 19] 
#[0 0 18 0 1 0 2 0 3 0 5 0 6 0 7] 
#[0 0 229 0 7] 
#[1 0 30 0 1 0 30 0 2 0 97 0 3 0 101 0 5 0 105 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 97 0 3 0 101 0 5 0 105 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 105 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 105 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 5 0 105 0 6 0 30 0 7] 
#[1 0 89 0 1 0 93 0 2 0 97 0 3 0 101 0 5 0 105 0 6 0 233 0 7] 
#[1 0 14 0 7 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 129 0 17 0 237 0 18 0 137 0 21 0 141 0 22] 
#[0 0 34 0 1 0 2 0 3 0 5 0 6 0 19] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 241 0 21 0 141 0 22] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 245 0 21 0 141 0 22] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 249 0 21 0 141 0 22] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 0 253 0 21 0 141 0 22] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 1 1 0 21 0 141 0 22] 
#[1 1 5 0 4 0 38 0 7 1 9 0 15] 
#[0 0 34 0 1 0 2 0 3 0 5 0 6 0 7] 
#[0 0 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7] 
#[0 1 13 0 7] 
#[1 0 30 0 1 0 30 0 2 0 213 0 3 0 30 0 4 0 217 0 5 0 221 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 213 0 3 0 30 0 4 0 217 0 5 0 221 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 4 0 30 0 5 0 221 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 4 0 30 0 5 0 221 0 6 0 30 0 7] 
#[1 0 30 0 1 0 30 0 2 0 30 0 3 0 30 0 4 0 30 0 5 0 221 0 6 0 30 0 7] 
#[1 0 113 0 8 0 117 0 9 0 121 0 10 0 125 0 14 1 17 0 21 0 141 0 22] 
#[0 0 42 0 4 0 7] 
#[0 0 34 0 1 0 2 0 3 0 4 0 5 0 6 0 7] 
#[1 0 205 0 1 0 209 0 2 0 213 0 3 0 46 0 4 0 217 0 5 0 221 0 6 0 46 0 7]
	).! !

SmaCCParser subclass: #ListNameParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ListNameParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/4/2018 22:28'!
cacheId
	^'2018-12-04T22:28:52.154207+01:00'! !

!ListNameParser class methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
definitionComment
"<name> :  [a-zA-Z]  ([a-zA-Z]  | [0-9] | _ | ')*;
<whitespace>:  (\x20|\xA0|\r)* ;

%root Root;
%prefix SmaccTutorial;
%annotate_tokens;
NameList
	: (Entite 'e' )+ {{list}}
	;
Entite
:( Name 'n1' "",""  Name 'n2' ){{entite}}
;
Name
	: <name>
	;"! !

!ListNameParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/4/2018 22:23'!
scannerClass
	^ListNameScanner! !

!ListNameParser class methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
startingStateForNameList
	^ 1! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:23'!
reduceActionForEntite1: nodes
	| result |
	result := SmaccTutorialentite new.
	result n1: ((nodes at: 1) at: 1).
	result commaToken: ((nodes at: 1) at: 2).
	result n2: ((nodes at: 1) at: 3).
	^ result! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:23'!
reduceActionForName1: nodes
	^ nodes at: 1! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:28'!
reduceActionForNameList1: nodes
	| result |
	result := SmaccTutoriallist new.
	result addNodes: (nodes at: 1) to: result es.
	^ result! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:28'!
reduceActionFor__Entite__e___1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^ result! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:28'!
reduceActionFor__Entite__e___2: nodes
	| result |
	result := nodes at: 1.
	self add: (nodes at: 2) to: result.
	^ result! !

!ListNameParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/4/2018 22:23'!
reduceActionFor__Name__n1______Name__n2__1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	^ result! !

!ListNameParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
reduceTable
^#(
	#(7 1 #reduceActionForName1:) 
	#(5 1 #reduceActionForNameList1:) 
	#(4 1 #reduceActionFor__Entite__e___1:) 
	#(9 1 #reduceActionForEntite1:) 
	#(6 1 #reduceActionForName1:) 
	#(4 2 #reduceActionFor__Entite__e___2:) 
	#(8 3 #reduceActionFor__Name__n1______Name__n2__1:)
	).! !

!ListNameParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
symbolNames
	^ #('","' '<name>' '<whitespace>' '( Entite ''e'')+' 'NameList' '( Entite ''e'')' 'Name' '( Name ''n1'' "," Name ''n2'')' 'Entite' 'E O F' 'error' 'B e g i n')! !

!ListNameParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
symbolTypes
	^ #(#SmaCCToken #SmaCCToken #SmaCCToken #OrderedCollection #SmaccTutoriallist #SmaccTutorialentite #SmaCCToken #OrderedCollection #SmaccTutorialentite #SmaCCToken #SmaCCToken #SmaccTutoriallist)! !

!ListNameParser methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:28'!
transitionTable
^#(
#[1 0 9 0 2 0 13 0 4 0 17 0 5 0 21 0 6 0 25 0 7 0 29 0 8 0 33 0 9] 
#[0 0 6 0 1] 
#[1 0 9 0 2 0 37 0 6 0 25 0 7 0 29 0 8 0 33 0 9 0 10 0 10] 
#[0 0 0 0 10] 
#[0 0 14 0 2 0 10] 
#[0 0 41 0 1] 
#[0 0 18 0 2 0 10] 
#[0 0 22 0 2 0 10] 
#[0 0 26 0 2 0 10] 
#[1 0 45 0 2 0 49 0 7] 
#[0 0 6 0 2 0 10] 
#[0 0 30 0 2 0 10]
	).! !

SmaCCParseNodeVisitor subclass: #ASTExpressionNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

ASTExpressionNodeVisitor subclass: #ASTExpressionEvaluator
	instanceVariableNames: 'functions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ASTExpressionNodeVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
visitBinary: aBinary
	^ self visitExpression: aBinary! !

!ASTExpressionNodeVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
visitExpression: anExpression
	^ self visitSmaCCParseNode: anExpression! !

!ASTExpressionNodeVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
visitFunction: aFunction
	^ self visitExpression: aFunction! !

!ASTExpressionNodeVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
visitNumber: aNumber
	^ self visitExpression: aNumber! !

SmaCCParseNodeVisitor subclass: #SmaccTutorialRootVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!SmaccTutorialRootVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
visitRoot: aRoot
	^ self visitSmaCCParseNode: aRoot! !

!SmaccTutorialRootVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
visitentite: anentite
	^ self visitRoot: anentite! !

!SmaccTutorialRootVisitor methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
visitlist: alist
	^ self visitRoot: alist! !

SmaCCParseNode subclass: #ASTExpressionNode
	instanceVariableNames: 'leftParenTokens rightParenTokens'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

ASTExpressionNode subclass: #ASTBinaryNode
	instanceVariableNames: 'left operator right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
acceptVisitor: anExpressionVisitor
	^ anExpressionVisitor visitBinary: self! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
left
	^ left! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
left: anASTExpressionNode
	self left notNil
		ifTrue: [ self left parent: nil ].
	left := anASTExpressionNode.
	self left notNil
		ifTrue: [ self left parent: self ]! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
nodeVariables
	^ #(#left #right)! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
operator
	^ operator! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
operator: aSmaCCToken
	operator := aSmaCCToken! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
right
	^ right! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
right: anASTExpressionNode
	self right notNil
		ifTrue: [ self right parent: nil ].
	right := anASTExpressionNode.
	self right notNil
		ifTrue: [ self right parent: self ]! !

!ASTBinaryNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
tokenVariables
	^ #(#operator)! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
acceptVisitor: anExpressionVisitor
	^ anExpressionVisitor visitExpression: self! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:46'!
ignoredCompositeTokenVariables
	^ #(#leftParenTokens #rightParenTokens)! !

!ASTExpressionNode methodsFor: 'generated-initialize-release' stamp: 'AllezSchema 12/4/2018 02:10'!
initialize
	super initialize.
	leftParenTokens := OrderedCollection new: 2.
	rightParenTokens := OrderedCollection new: 2.! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
leftParenTokens
	^ leftParenTokens! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
leftParenTokens: anOrderedCollection
	leftParenTokens := anOrderedCollection! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
rightParenTokens
	^ rightParenTokens! !

!ASTExpressionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
rightParenTokens: anOrderedCollection
	rightParenTokens := anOrderedCollection! !

ASTExpressionNode subclass: #ASTFunctionNode
	instanceVariableNames: 'nameToken leftParen arguments commaTokens rightParen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
acceptVisitor: anExpressionVisitor
	^ anExpressionVisitor visitFunction: self! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
arguments
	^ arguments! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
commaTokens
	^ commaTokens! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
compositeNodeVariables
	^ #(#arguments)! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:46'!
compositeTokenVariables
	^ #(#commaTokens)! !

!ASTFunctionNode methodsFor: 'generated-initialize-release' stamp: 'AllezSchema 12/4/2018 02:41'!
initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
leftParen
	^ leftParen! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
leftParen: aSmaCCToken
	leftParen := aSmaCCToken! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
nameToken
	^ nameToken! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
nameToken: aSmaCCToken
	nameToken := aSmaCCToken! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
rightParen
	^ rightParen! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
rightParen: aSmaCCToken
	rightParen := aSmaCCToken! !

!ASTFunctionNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:41'!
tokenVariables
	^ #(#nameToken #leftParen #rightParen)! !

ASTExpressionNode subclass: #ASTNumberNode
	instanceVariableNames: 'numberToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!ASTNumberNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
acceptVisitor: anExpressionVisitor
	^ anExpressionVisitor visitNumber: self! !

!ASTNumberNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
numberToken
	^ numberToken! !

!ASTNumberNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
numberToken: aSmaCCToken
	numberToken := aSmaCCToken! !

!ASTNumberNode methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 02:10'!
tokenVariables
	^ #(#numberToken)! !

SmaCCParseNode subclass: #SmaccTutorialRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!SmaccTutorialRoot methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
acceptVisitor: aRootVisitor
	^ aRootVisitor visitRoot: self! !

SmaccTutorialRoot subclass: #SmaccTutorialentite
	instanceVariableNames: 'n1 commaToken n2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
acceptVisitor: aRootVisitor
	^ aRootVisitor visitentite: self! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
commaToken
	^ commaToken! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
commaToken: aSmaCCToken
	commaToken := aSmaCCToken! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
n1
	^ n1! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
n1: aSmaCCToken
	n1 := aSmaCCToken! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
n2
	^ n2! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
n2: aSmaCCToken
	n2 := aSmaCCToken! !

!SmaccTutorialentite methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
tokenVariables
	^ #(#n1 #commaToken #n2)! !

SmaccTutorialRoot subclass: #SmaccTutoriallist
	instanceVariableNames: 'es'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmaCC-Tutorial'!

!SmaccTutoriallist methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
acceptVisitor: aRootVisitor
	^ aRootVisitor visitlist: self! !

!SmaccTutoriallist methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
compositeNodeVariables
	^ #(#es)! !

!SmaccTutoriallist methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
es
	^ es! !

!SmaccTutoriallist methodsFor: 'generated' stamp: 'AllezSchema 12/4/2018 22:23'!
es: anOrderedCollection
	self setParents: self es to: nil.
	es := anOrderedCollection.
	self setParents: self es to: self! !

!SmaccTutoriallist methodsFor: 'generated-initialize-release' stamp: 'AllezSchema 12/4/2018 22:23'!
initialize
	super initialize.
	es := OrderedCollection new: 2.! !
